# Each website can access the API for their own domain.  This allows us
# to issue per-domain cookies for api.site.org instead of third-party
# cookies for api.sutty.nl that are going to be blocked anyway.
#
# We put a rate limit in API calls in a way that you can get a cookie
# for contact form and only POST it a minute later.  If you reply too
# quickly you'll get a 503 error.  Cookies last 30 minutes so you can
# make 29 POSTs from it before having to renew it.
#
# Requests are limited per-visitor for now.  This opens up to (1440 *
# attacker) requests but limiting by site allows a single attacker to
# block requests for everyone else.
#
# {https://0xacab.org/sutty/sutty/issues/75}

map $uri $limit_req_by_uri {
  default                             "";
  ~/v1/sites/[a-z0-9\-.]+/contact/    $binary_remote_addr;
  ~/v1/sites/[a-z0-9\-.]+/invitades/  $binary_remote_addr;
  ~/v1/sites/[a-z0-9\-.]+/posts/      $binary_remote_addr;
}

map $ssl_server_name $certificate {
  default $ssl_server_name;
  api.sutty.nl sutty.nl;
  $ssl_server_name $ssl_server_name;
}

limit_req_zone $limit_req_by_uri zone=api:10m rate=2r/m;

server {
  server_name api.sutty.nl api.*;

  access_log syslog:server=unix:/tmp/access_log.socket,nohostname access_logd;

  # Redirect to "Central Validation Server"
  location ^~ /.well-known/acme-challenge/ {
    return 301 http://certbot.{{ sutty }}$request_uri;
  }

  listen 80;
  listen 443 ssl;
  http2 on;

  add_header Cache-Control no-cache;
  add_header Strict-Transport-Security "max-age=31536000; includeSubDomains; preload";
  add_header X-Frame-Options "sameorigin";
  add_header X-XSS-Protection "1; mode=block";
  add_header X-Content-Type-Options "nosniff";
  add_header Referrer-Policy "strict-origin-when-cross-origin";
  add_header Access-Control-Allow-Origin "*";
  # TODO: Remove panel from media-src
  add_header Content-Security-Policy-Report-Only "default-src 'self'; media-src 'self' {{ panel_env_panel_url }}; style-src 'self' 'unsafe-inline'; script-src https: 'self'; font-src data: 'self'; img-src https: 'self'; object-src 'none'; frame-src https: 'self'; connect-src 'self' https://*.{{ sutty }}; report-uri {{ panel_env_api_url }}/v1/csp_reports.json";
  add_header Permissions-Policy "interest-cohort=()";

  ssl_certificate /etc/letsencrypt/live/$certificate/fullchain.pem;
  ssl_certificate_key /etc/letsencrypt/live/$certificate/privkey.pem;
  ssl_session_timeout 1d;
  ssl_session_cache shared:SSL:10m;
  ssl_session_tickets off;
  # Basado en https://ssl-config.mozilla.org/#server=nginx&version=1.22.1&config=intermediate&openssl=3.0.10&guideline=5.7
  ssl_protocols TLSv1.2 TLSv1.3;
  ssl_ciphers ECDHE-ECDSA-AES128-GCM-SHA256:ECDHE-RSA-AES128-GCM-SHA256:ECDHE-ECDSA-AES256-GCM-SHA384:ECDHE-RSA-AES256-GCM-SHA384:ECDHE-ECDSA-CHACHA20-POLY1305:ECDHE-RSA-CHACHA20-POLY1305:DHE-RSA-AES128-GCM-SHA256:DHE-RSA-AES256-GCM-SHA384:DHE-RSA-CHACHA20-POLY1305;
  ssl_early_data on;

  if ($redirect_to_https) {
    return 301 https://$http_host$request_uri;
  }

  # Handle limited request error by showing a page informing the visitor
  # they can retry in a minute.  If they don't have a custom 503 page,
  # we'll show Sutty's.
  proxy_intercept_errors on;
  error_page 503 /503.html;
  location = /503.html {
    root /srv/http/$certificate/default;
    try_files /503.html @sutty503;
  }

  # Sutty returns 428 when it can't validate the information
  error_page 428 /428.html;
  location = /428.html {
    root /srv/http/$certificate/default;
    try_files /428.html @sutty428;
  }

  location / {
    limit_req zone=api;

    limit_except GET POST PUT PATCH DELETE OPTIONS HEAD {
      deny all;
    }

    try_files nonexistent @api;
  }

  # Show Sutty's 503 error page.
  location @sutty503 {
    root /srv/http/{{ sutty }}/default;
  }

  location @sutty428 {
    root /srv/http/{{ sutty }}/default;
    try_files /428.html /503.html;
  }

  location @api {
    proxy_set_header X-Forwarded-Proto $scheme;
    proxy_set_header X-Forwarded-Ssl on;
    proxy_set_header X-Forwarded-Port $server_port;
    proxy_set_header X-Forwarded-Host $http_host;
    proxy_set_header Host $http_host;

    set $api {{ panel_container }}:3100;
    proxy_pass http://$api;
  }
}
